/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.removeduplicatesusingstream;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

/**
 *
 * @author omozegieaziegbe
 */
public class RemoveDuplicatesUsingStream {

    public static void main(String[] args) {

        // Create a HashMap with key-value pairs (including duplicates)
        Map<String, String> hashMap = new HashMap<String, String>();
        hashMap.put("Thomas", "Age of Reason");
        hashMap.put("Charles", "Olivier Twist");
        hashMap.put("Jonathan", "Gullivers Travels");
        hashMap.put("Daniel", "Robinson Crusoe");
        hashMap.put("Thomass", "Age of Reason"); // Duplicate Value
        hashMap.put("Chinua", "Chike and The River");
        hashMap.put("John", "Gullivers Travels");// Duplicate Value

        System.out.printf("Original HashMap: %s%n", hashMap);

        // Set in which we keep the existing values
        Set<String> existing = new HashSet<String>();
        hashMap = hashMap.entrySet()
                .stream()
                .filter(entry -> existing.add(entry.getValue()))
                .collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
        System.out.printf("HashMap without Duplicates: %s%n", hashMap);

        //Example on how to Remove duplicates from hashmap using Streams and Set
        //  Use Java Streams to extract the unique values
        Map<String, String> result = hashMap.entrySet()
                .stream()
                .collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue, (existing1, replacement) -> existing1));

        // Print the unique values
        System.out.println("Unique Values" + result);
    }
}
